<?php

function save_braintree_donation_config_info(){
	if(isset($_POST['save_braintree_api_config'])){
		$environment = $_POST['activate_braintree_environment'];
		
			$config = array('environment'=>$environment, 'production'=>array(
					'merchantId'=>$_POST['braintree_production_merchantId'],
				'private_key'=>$_POST['braintree_production_private_key'],
					 'public_key'=>$_POST['braintree_production_public_key'], 
					'currency'=>$_POST['prod_donation_currency']	
			), 'sandbox'=>array(
					'merchantId'=>$_POST['braintree_sandbox_merchantId'],
					'private_key'=>$_POST['braintree_sandbox_private_key'],
					'public_key'=>$_POST['braintree_sandbox_public_key'],
					'currency'=>$_POST['sand_donation_currency']
			)
			);
			
			update_braintree_payments_config('braintree_api_keys_config', $config);
	}
	elseif(isset($_POST['save_braintree_message_config'])){
		
		$config = array('receipt_message'=>$_POST['braintree_receipt_message'],
						'donation_message'=>$_POST['braintree_donation_message']);
		
		update_braintree_payments_config('braintree_messages_config', $config);
		
	}
	elseif(isset($_POST['save_braintree_merchant_account_config'])){
		$config = array('production'=>array(
							'merchant_account_id'=>$_POST['production_account']),
						'sandbox'=>array('merchant_account_id'=>$_POST['sandbox_account']));
		
		update_braintree_payments_config('braintree_merchant_account_id_config', $config);
	}
	elseif(isset($_POST['save_braintree_ui_config'])){
		if(isset($_POST['paypal_enabled'])){
			$paypal = 'true';
		}
		$donation_form = $_POST['donation_form'];
		$config = array('donation_form'=>$donation_form, 'paypal_active'=>$paypal,
				 'donation_button'=>array('background_color'=>$_POST['background-color'],
				 		 'border_color'=>$_POST['border-color']));
		update_braintree_payments_config('braintree_donation_form_settings', $config);
	}
	elseif(isset($_POST['activate_license'])){
		$result = apply_filters('activate_braintree_payments_license', 'activate_braintree_payments_license');
		if(is_wp_error($result)){
			wp_redirect($_SERVER['PHP_SELF'].'?page=braintree-payments-activation&activation_error');
		}
		else {
			wp_redirect($_SERVER['PHP_SELF'].'?page=braintree-payments-activation&activation_success');
		}
	}
	elseif(isset($_POST['save_woopayments'])){
		$woopayments_enabled = (isset($_POST['enable-woopayments'])) ? true : false;
		$paypal_enabled = (isset($_POST['enable_paypal'])) ? 'true' : 'false';
		$payment_form_type = $_POST['payment_form_type'];
		$payment_form = $_POST['selected_payment_form'];
		$default_gateway = (isset($_POST['default_gateway'])) ? true : false;
		$woo_config = maybe_unserialize(get_option('woocommerce_braintree_payment_gateway_settings'));
		$woopayments_config = array('payment_form'=>$payment_form,
				'woopayments_paypal_enabled'=>$paypal_enabled, 'payment_form_type'=>$payment_form_type
		);
		
		update_braintree_payments_config('braintree_payments_woocommerce_config', $woopayments_config);
		
		if($default_gateway){
			update_option('woocommerce_default_gateway', 'braintree_payment_gateway');
		}
		if($woopayments_enabled){
			$woo_config['enabled'] = 'yes';
			update_option('woocommerce_braintree_payment_gateway_settings', $woo_config);
		}
		elseif (! $woopayments_enabled){
			$woo_config['enabled'] = 'no';
			update_option('woocommerce_braintree_payment_gateway_settings', $woo_config);
		}
	}
	
}
add_action('admin_init', 'save_braintree_donation_config_info');

function braintree_donations_admin_menu_option(){
	add_menu_page('Braintree Payments', 'Braintree Payments', 'manage_options', 'braintree-payments-menu', null, null, '6');
	add_submenu_page('braintree-payments-menu', 'API KEYS', 'Braintree Settings', 'manage_options', 'braintree-payment-settings', 'show_braintree_payments_settings');
	add_submenu_page('braintree-payments-menu', 'Woocommerce Payments', 'Woocommerce Payments', 'manage_options', 'braintree-payments-woocommerce-settings', 'show_braintree_payments_woocommerce_settings');
	add_submenu_page('braintree-payments-menu', 'Instructions', 'Instructions', 'manage_options', 'braintree-payments-instructions', 'show_braintree_instructions');
	add_submenu_page('braintree-payments-menu', 'Activate License', 'Activate License', 'manage_options', 'braintree-payments-activation', 'show_braintree_payments_activation_form');
	remove_submenu_page('braintree-payments-menu', 'braintree-payments-menu');

}
add_action('admin_menu', 'braintree_donations_admin_menu_option');

 function braintree_donations_admin_scripts(){
	$path = plugin_dir_url(__FILE__);
	wp_enqueue_style('braintree-admin-style', $path.'css/braintree-payments-admin.css');
	wp_enqueue_script('braintree-payments-admin', $path.'js/braintree-payments-admin.js');
	wp_enqueue_style('braintree-payments', BRAINTREE_DONATIONS_ASSETS.'css/braintree-payments.css');
	wp_enqueue_script('braintree-admin-colors', $path.'js/tinyColorPicker-master/colors.js');
	wp_enqueue_script('braintree-admin-color-picker-color', $path.'js/tinyColorPicker-master/jqColorPicker.js');
	} 
add_action('admin_init','braintree_donations_admin_scripts');

function get_braintree_settings_header(){
	?>
	<div class="braintree-header"><div class="logo-inner">
	 <a><img src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/braintree-logo-white.svg'?>" /></a>
	 </div>
	 <ul>
	 	<li><a href="?page=braintree-payment-settings&tab=braintree-api-settings">Braintree API Keys</a></li>
	 	<li><a href="?page=braintree-payment-settings&tab=braintree-message-config">Message Config</a></li>
	 	<li><a href="?page=braintree-payment-settings&tab=braintree-merchant-account-config">Merchant Account Id</a></li>
	 	<li><a href="?page=braintree-payment-settings&tab=braintree-donation-ui-config">Donation UI Settings</a></li>
	 </ul>
	</div>
	<?php 
}

function show_braintree_payments_settings(){
	
	$tab = null;
	
	if(isset($_REQUEST['tab'])){
		$tab = $_REQUEST['tab'];
	}
	
	if($tab == 'braintree-message-config'){
		show_braintree_messages_config();
	}
	if($tab == 'braintree-merchant-account-config'){
		show_braintree_merchant_account_config();
	}
	if($tab == 'braintree-donation-ui-config'){
		show_braintree_donation_ui_config();
	}
	if($tab == 'braintree-api-settings' || empty($tab)){
	
	if(! current_user_can('manage_options')){
		wp_die('You do not have sufficient rights to access this page');
	}
	//$path = plugin_dir_url();
	$config = maybe_unserialize(get_braintree_payments_config('braintree_api_keys_config'));
	
	$license_active = (get_braintree_payments_config('braintree_payments_license_status') == 'active') ? true : false;
	if($license_active){
	$production_active = ($config['environment'] === 'production') ? true : false;
	}
	else {
		$production_active = false;
	}
	get_braintree_settings_header();
	?>

	<div class="braintree_payment_wrapper">
	<form class="braintree-payments-form" name="braintree_donations_form" method="post" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF'].'?page=braintree-payment-settings&tab=braintree-api-settings') ?>">
	<input type="hidden" name="save_braintree_api_config" value="save"/>
	<input type="hidden" id="ajax" value="<?php echo admin_url().'admin-ajax.php'?>"/>	
		<div class="account-title"><h1><span><img class="donation-config" class="instruction-video" src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/donations-config.png'?>" /></span></h1></div>
		<div class="table-wrapper">
		<div class="braintree-payments-div-table"><h2><span><img class="braintree-logo-keys" src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/braintree-production-logo.svg'?>"/></span></h2>
			<div class="prod-question">
				<img class="donation-question-prod" src="<?php echo BRAINTREE_DONATIONS_ASSETS.'/images/question.png'?>"/>
			<div id="instructions-prod" class="braintree-instructions">
			<h3>Braintree Donation Instructions</h3>
			<div><p>In order to use the Braintree Donations plugin, you must
			enter your Braintree API keys. These keys can be located by following these directions:</br>
			<b>Production:</b></br>
			1.<a href="https://www.braintreegateway.com/login" target="_blank">Login:</a></br>
			2. Account > My User > View API Keys</br>
			3. Copy and past the merchantId, private key, and public key for your production environment.</p>
		</div>
			</div>
			</div>
			<div id="connection-messages" class="connection-messages"><img class="close-icon" src="<?php echo BRAINTREE_DONATIONS_ASSETS.'images/close-donation.png'?>"/></div>
		<table>
			<tbody>
				<tr>
					<th>Merchant Id</th>
					<th>Public Key</th>
					<th>Private Key</th>
					<th>Currency</th>
					<th>Active</th>
				</tr>
				<tr>
				<td><input type="text" name="braintree_production_merchantId" id="braintree_production_merchantId" value="<?php if($config){echo $config['production']['merchantId'];}?>" <?php if(! $license_active){?> disabled <?php }?>/></td>
				<td><input type="text" id="braintree_production_public_key" name="braintree_production_public_key" value="<?php if($config){ echo $config['production']['public_key'];}?>" <?php if(! $license_active){?> disabled <?php }?>/></td>
				<td><textarea type="text" name="braintree_production_private_key" id="braintree_production_private_key" <?php if(! $license_active){?> disabled <?php }?>><?php if($config){ echo $config['production']['private_key'];}?></textarea></td>
				<td><select name="prod_donation_currency" <?php if(! $license_active){?> disabled <?php }?>><?php get_donation_currency($config['production'])?></select>
				<td><input type="radio" value="production" name="activate_braintree_environment" <?php if($production_active){?> checked<?php }?> <?php if(! $license_active){?> disabled <?php }?>/><td>
				</tr>
			</tbody>
		</table>
		<div><button id="production_test" value="production" class="button-secondary test-connection" <?php if(! $license_active){?> disabled <?php }?>>Test Connection</button></div>
		</div>
		</div>
		<div class="table-wrapper">
		<div class="braintree-payments-div-table"><h2><span><img class="braintree-logo-keys" src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/braintree-sandbox-logo.svg'?>"/></span></h2>
		<div class="sand-question">
		<img class="donation-question-sand" src="<?php echo BRAINTREE_DONATIONS_ASSETS.'/images/question.png'?>"/>
		<div id="instructions-sand" class="braintree-instructions">
			<h3>Braintree Donation Instructions</h3>
			<div><p>In order to use the Braintree Donations plugin, you must
			enter your Braintree API keys. These keys can be located by following these directions:</br>
			<b>Sandbox:</b></br>
			1. <a href="https://sandbox.braintreegateway.com/login" >Login:</a></br>
			2. Account > My User > View API Keys</br>
			3. Copy and past the merchantId, private key, and public key for your sandbox environment.</p></div>
			</div>
		</div>
		<table>
			<tbody>
				<tr>
					<th>Merchant Id</th>
					<th>Public Key</th>
					<th>Private Key</th>
					<th>Currency</th>
					<th>Active</th>
				</tr>
				<tr>
				<td><input type="text" name="braintree_sandbox_merchantId" id="braintree_sandbox_merchantId" value="<?php if($config){ echo $config['sandbox']['merchantId'];}?>"/></td>
				<td><input type="text" id="braintree_sandbox_public_key" name="braintree_sandbox_public_key" value="<?php if($config){echo $config['sandbox']['public_key'];}?>"/></td>
				<td><textarea name="braintree_sandbox_private_key" id="braintree_sandbox_private_key"><?php if($config){echo $config['sandbox']['private_key'];}?></textarea></td>
				<td><select name="sand_donation_currency"><?php get_donation_currency($config['sandbox'])?></select>
				<td><input type="radio" value="sandbox" name="activate_braintree_environment" <?php if(!$production_active){?> checked<?php }?>/><td>
				</tr>
			</tbody>
		</div>
		</table>
		<div><button id="sandbox_test" value="sandbox" class="button-secondary test-connection">Test Connection</button></div>
		</div>
		</div>
		<div><input class="braintree-payments-save" type="submit" value="Save"/></div>
		</form>
	</div> <!-- braintree_payment_form -->
	<div class="connection-message-overlay"><div class="loader">
  <span></span>
  <span></span>
  <span></span>
  <span></span>
  <span></span>
  <span></span>
  <span></span>
  <span></span>
  <span></span>
  <span></span>
  <span></span>
  <span></span>
  <span></span>
  <span></span>
  <span></span>
</div></div>
	<?php
	}
}

function show_braintree_messages_config(){
	
	if(! current_user_can('manage_options')){
		wp_die('You do not have sufficient rights to access this page');
	}
	//$path = plugin_dir_url();
	$config = maybe_unserialize(get_braintree_payments_config('braintree_messages_config'));

	get_braintree_settings_header();
	?>
	<div class="braintree_payment_form">
	<form class="braintree-payments-form" name="braintree_donations_form" method="post" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF'].'?page=braintree-payment-settings&tab=braintree-message-config') ?>">
	<input type="hidden" name="save_braintree_message_config" value="save"/>
	<div class="receipt-message">
	<h2><span><img class="messages" src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/paypal-receipt.svg'?>"/></span></h2>
	<div class="receipt-question">
	<img class="donation-question-message" src="<?php echo BRAINTREE_DONATIONS_ASSETS.'/images/question.png'?>"/>
	<div id="receipt-message" class="braintree-instructions">
	<h3>Paypal Receipt Message</h3>
	<div><p>The message you enter here will appear on the customers Paypal email receipt if they choose Paypal as the form of payment.</br>
	<b>Message: Max 127 characters</b></br>
	1. Enter the message you want to appear on your donor's billing statement.</br>
			2. Save</br>
			</div>
				</div>
		</div>
			<div class="config-div">
				<textarea id="braintree_receipt_message" name="braintree_receipt_message" rows="2" cols="30"><?php if($config){ echo $config['receipt_message'];}?></textarea>
			</div>
			</div>
	
			<div class="donation-message">
		<h2><span><img class="messages" src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/success-message.svg'?>"/></span></h2>
		<div class="donation-question">
		<img class="donation-question-message" src="<?php echo BRAINTREE_DONATIONS_ASSETS.'/images/question.png'?>"/>
		<div id="instructions-message" class="braintree-instructions">
				<h3>Donation Success Message</h3>
			<div><p>This message will appear if the payment is successfully processed for the Donation.</br>
			Example: Thank you for your Donation!
			1. Enter the message you want to appear on success of payment processing.</br>
			2. Save</br>
			</div>
				</div>
		</div>
			<div class="config-div">
				<textarea maxlength="127" id="braintree_donation_message" name="braintree_donation_message" rows="2" cols="30"><?php if($config){ echo $config['donation_message'];}?></textarea>
			</div>
			</div>
	
		<div><input class="braintree-payments-save" type="submit" value="Save"/></div>
		</form>
		</div>
		
		<?php 
}
function show_braintree_merchant_account_config(){
	if(! current_user_can('manage_options')){
		wp_die('You do not have sufficient rights to access this page');
	}
	
	$config = maybe_unserialize(get_braintree_payments_config('braintree_merchant_account_id_config'));
	
	get_braintree_settings_header();
	?>
	<div class="braintree_payment_form">
	<form class="braintree-payments-form" name="braintree_donations_form" method="post" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF'].'?page=braintree-payment-settings&tab=braintree-merchant-account-config') ?>">
		 <input type="hidden" name="save_braintree_merchant_account_config"/>
		<div>
		<div class="account-title">
		<h1>
		<span><img class="merchant-account" src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/merchant-account-id.svg'?>"/>
			</span>
		</h1></div>
		<div class="account-config-div">
		<h3>Production:</h3>
		<div class="account-question">
		<img class="donation-question-message" src="<?php echo BRAINTREE_DONATIONS_ASSETS.'/images/question.png'?>"/>
		<div id="account-message" class="braintree-instructions">
				<h3>Merchant Account Id</h3>
			<div><p>The merchant account ID used to create a transaction. 
			Currency is also determined by merchant account ID so make sure that your currecny configured on the API Keys page is the same.
			If no merchant account ID is specified, we will use your default merchant account.</br>
		</br>
			</div>
				</div>
		</div>
		  <input type="hidden" name="save_braintree_merchant_account_config"/>
			<table>
				<tbody>
					<tr><th>Merchant Account Id</th></tr>
					<tr><td><input type="text" name="production_account" value="<?php if($config){ echo $config['production']['merchant_account_id'];}?>"/></td></tr>
				</tbody>
			</table>
			</div>
			
		<div class="account-config-div">
		<h3>Sandbox:</h3>
		<div class="account-question">
		<img class="donation-question-message" src="<?php echo BRAINTREE_DONATIONS_ASSETS.'/images/question.png'?>"/>
		<div id="account-message" class="braintree-instructions">
				<h3>Merchant Account Id</h3>
			<div><p>The merchant account ID used to create a transaction. 
			Currency is also determined by merchant account ID so make sure that your currecny configured on the API Keys page is the same.
			If no merchant account ID is specified, we will use your default merchant account.</br>
		</br>
			</div>
				</div>
		</div>
			<table>
				<tbody>
					<tr><th>Merchant Account Id</th></tr>
					<tr><td><input type="text" name="sandbox_account" value="<?php if($config){echo $config['sandbox']['merchant_account_id'];}?>"/></td></tr>
				</tbody>
			</table>
			</div>
			
				<div>
		
				<div><input class="braintree-payments-save" type="submit" value="Save"/></div>
		</form>
		
		</div>
	</div>
	
	<?php 
}

function show_braintree_donation_ui_config(){
	$config = get_braintree_payments_config('braintree_donation_form_settings');
	$paypal = ($config['paypal_active'] == 'true') ? true : false;
	$custom = ($config['donation_form'] == 'custom') ? true : false;
	$background_color = $config['donation_button']['background_color'];
	$border_color = $config['donation_button']['border_color'];
	$bd = new Braintree_Donations();
	get_braintree_settings_header();
	?>
	
	<div class="braintree_payment_form">
		<form class="braintree-payments-form" name="braintree_donations_form" method="post" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF'].'?page=braintree-payment-settings&tab=braintree-donation-ui-config') ?>">
			<div><div class="account-title">
			<h1><span><img class="ui-settings" src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/donation-ui-settings.svg'?>"/></span></h1>
			</div></div>
				<div class="settings-and-design">
				<div class="enable-paypal">
				<h2>Enable Paypal</h2>
				<div><span><input type="checkbox" name="paypal_enabled" id="paypal_enabled" <?php if($paypal){?>checked="checked"<?php }?>/></span></div>
				</div>
				<div class="donation-button-design">
					<h2>Donation Button Design</h2>
					<div class="pick-colors">
					<div class="button-styles"><div><span>Background Color</span></div><input type="text" class="color" id="color-picker" name="background-color" value="<?php echo $background_color?>"/></div>
					<div><div><span>Border Color</span></div><input type="text" class="color" id="color-picker2" name="border-color" value="<?php echo $border_color?>"/></div>
					</div>
					<div class="pick-colors"><div><span>Click Button to Update</span></div><?php echo $bd->get_donation_button()?>
				</div>
				<script>
				var $ = jQuery;
				$(function(){
					$('.color').colorPicker();
				})
				</script>
				</div>
				</div>
					<div class="config-container-col">
					<h2>Custom UI</h2>
						<div class="ui-setting"><span>Active: </span>
							<input type="radio" class="set-ui" name="donation_form" id="donation_form" <?php if($custom){?>checked="checked"<?php }?> value="custom"/></div>
						<div class="ui-image"><img id="custom-ui-img" src="<?php if($paypal){ echo BRAINTREE_DONATIONS_ADMIN.'images/custom-ui-2.png'; } else{ echo BRAINTREE_DONATIONS_ADMIN.'images/custom-ui.png';}?>"/></div>
					</div>
			
				
					<div class="config-container-col">
					<h2>Drop In UI</h2>
						<div class="ui-setting"><span>Active:</span>
							<input type="radio" class="set-ui" name="donation_form" id="donation_form" <?php if(!$custom){?>checked="checked"<?php }?>  value="dropin"/></div>
						<div class="ui-image"><img src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/dropin-ui-2.png'?>"/></div>
					</div>
			
			 <input type="hidden" name="save_braintree_ui_config"/>
			 <input type="hidden" id="custom-paypal" value="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/custom-ui-2.png'?>"/>
			 <input type="hidden" id="custom-ui" value="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/custom-ui.png'?>"/>
			<div><input class="braintree-payments-save" type="submit" value="Save"/></div>
		</form>
	</div>
	<?php 
}

function show_braintree_instructions(){
	
	get_braintree_settings_header();
	?>
	<h1><span><img class="instruction-video" src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/instruction-video.svg'?>" /></span></h1>
	<div class="braintree_payment_form">
		<div>
			<iframe width="560" height="315" src="https://www.youtube.com/embed/WQ40guZXWuM" frameborder="0" allowfullscreen></iframe>
				</div>
	</div>	
	<?php 
}
function show_braintree_payments_activation_form(){
	
	$is_error = (isset($_REQUEST['activation_error'])) ? true : false;
	$success = (isset($_REQUEST['activation_success'])) ? true : false;
	
	get_braintree_settings_header();
	?>
		<div class="braintree_donations_wrapper">
			<form class="braintree-payments-form" name="braintree_donations_form" method="post" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF'].'?page=braintree-payments-activation') ?>">
			<div class="account-title">
			<h1><span><img class="ui-settings" src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/activation-key.png'?>"/></span></h1>
			</div></div>
			<?php if($is_error){?>
			<div class="activation-errors"><span>Your license key could not be validated.</span></div>
			<?php } if($success){?>
			<div class="activation-success"><span>Your license has been validated!</span></div>
			<?php }?>
			<div><input class="braintree-payment-activation" type="text" name="braintree_license_activation_key" placeholder="License Key"/></div>
			<div><input name="activate_license" class="braintree-payments-save" type="submit" value="Activate"/></div>
			</form>
		</div>
		
<?php }

function show_braintree_payments_woocommerce_settings(){
	$config = get_braintree_payments_config('braintree_payments_woocommerce_config');
	if($config){
	$payment_form = $config['payment_form'];
	$custom_form = ($config['payment_form_type'] == 'custom') ? true : false;
	$paypal_enabled = ($config['woopayments_paypal_enabled'] == 'true') ? true : false;
	}
	else{
		$payment_form = false;
		$custom_form = false;
		$paypal_enabled = false;
	}
	$woo_config = maybe_unserialize(get_option('woocommerce_braintree_payment_gateway_settings'));
	
	$enabled = ($woo_config['enabled'] == 'yes') ? true : false;
	
	
	$number = substr($payment_form, -1);
	get_braintree_settings_header();
	?>
	<div class="braintree_payment_wrapper">
			<form class="braintree-payments-form" name="braintree_donations_form" method="post" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF'].'?page=braintree-payments-woocommerce-settings') ?>">
			<div class="account-title">
			<h1><span><img class="ui-settings" src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/woocommerce_settings.png'?>"/></span></h1>
			</div>
			<div class="woopayments-setting">
			<div class="woopayments-enabled"><div><span>Enable Woopayments</span></div><div><input type="checkbox" name="enable-woopayments" value="enable-woopayments" <?php if($enabled){?>checked<?php }?>></div></div>
			<div class="woopayments-question">
		<img class="donation-question-message" src="<?php echo BRAINTREE_DONATIONS_ASSETS.'/images/question.png'?>"/>
		<div class="braintree-instructions">
				<h3>Enable Woopayments</h3>
			<div><p>If woopayments is enabled, you can process credit cards and paypal payments using your Braintree account.
			The form that you have selected will appear on the checkout page of your website. </br>
		</br>
			</div>
				</div>
				</div>
		</div>
		<div class="woopayments-setting">
			<div class="woopayments-paypal-enabled"><div><span>Enable Paypal</span></div><div><input type="checkbox" name="enable_paypal" value="enable-paypal" <?php if($paypal_enabled){?>checked<?php }?>></div></div>
			<div class="woopayments-question">
		<img class="donation-question-message" src="<?php echo BRAINTREE_DONATIONS_ASSETS.'/images/question.png'?>"/>
		<div class="braintree-instructions">
				<h3>Enable Paypal</h3>
			<div><p>If paypal is enabled, your customers will have the option to checkout using paypal.</br>
		</br>
			</div>
				</div>
				</div>
		</div>
		<div></div>
			<div class="woopayments-form">
			<div class="payment-form-header"><h2>Custom Payment Form</h2></div><div class="form-type"><input type="radio" name="payment_form_type" value="custom" <?php if($custom_form){?>checked="checked"<?php }?>/></div>
				<div class="left-click"><span><img src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/left-click.png'?>"/></span></div>
				<div class="selected-payment-form">
				<?php for($i = 0; $i < 3; $i++){
					$current_payment_form = 'payment_form_'.$i;
					?>
						<div class="woopayments-form-image" <?php if($payment_form == $current_payment_form){?> style="display: block;" <?php } else {?>style="display: none"<?php }?> id="<?php echo $current_payment_form?>"><img src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/woopayments_form_'.$i.'.png'?>"/>
						<div><h3><?php echo $current_payment_form?></h3></div>
						</div>
				<?php }?>
				</div>
				<div class="right-click"><span><img src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/right-click.png'?>"/></span></div>
			</div>
			<div class="woopayments-form">
				<div class="payment-form-header"><h2>Braintree Dropin Form</h2></div><div class="form-type"><input type="radio" name="payment_form_type" value="dropin" <?php if(! $custom_form){?>checked="checked"<?php }?>/></div>
					<div class="selected-payment-form">
						<div class="woopayments-form-image"><img src="<?php echo BRAINTREE_DONATIONS_ADMIN.'images/dropin-ui.png'?>"/></div>
					</div>
			</div>
			</div>
			<div><input name="save_woopayments" class="braintree-payments-save" type="submit" value="Save"/></div>
	</div>
	<input type="hidden" <?php if($payment_form){?>value="<?php echo $payment_form?>"<?php }else{?>value="payment_form_0" <?php }?> id="selected_payment_form" name="selected_payment_form"/>
	<input type="hidden" <?php if($number){?>value="<?php echo $number?>"<?php } else {?>value="0"<?php }?> id="current_form_number"/>
	</form>
	</div>
	<?php 
}
function get_donation_currency($environment){
	$currencies  = Currencies::get_currencies();
	if(empty($environment['currency'])){
		$current_currency = 'USD';
	}
	else {
		$current_currency = $environment['currency'];
	}
	foreach($currencies as $currency => $symbol){
		?>
			<option value="<?php echo $currency?>" <?php if($currency == $current_currency){?>selected="selected"<?php }?>><?php echo $currency.' - '.$symbol?></option>
		<?php 
		
	}
}
	
function test_braintree_connection(){
	$environment = $_POST['environment'];
	$merchantId = $_POST['merchantId'];
	$publicKey = $_POST['publicKey'];
	$privateKey = $_POST['privateKey'];
	
	$args = array('environment'=>$environment,
			 'merchantId'=>$merchantId, 
			'publicKey'=>$publicKey, 
			'privateKey'=>$privateKey
	);
	$result = Braintree_Donations::test_braintree_connection($args);
	
	echo json_encode($result);
	wp_die();
}
add_action('wp_ajax_test_braintree_connection', 'test_braintree_connection');

function activate_braintree_payments_license(){
	$license_key = $_POST['braintree_license_activation_key'];
	
	$api_params = array('slm_action'=>'slm_activate', 
			'secret_key'=>BRAINTREE_LICENSE_VERIFICATION_KEY,
			'license_key'=>$license_key
			
	);
	$response = wp_remote_get(add_query_arg($api_params, BRAINTREE_LICENSE_ACTIVATION_URL), array('timeout' => 20, 'sslverify' => false));
	
	if(is_wp_error($response)){
		return new WP_Error('error', 'Your license could not be 
				activated at this time. Please email mr.clayton@bradstreet.co for activation.');
	}
	
	$response['body'] = json_decode($response['body']);
	
	if(is_wp_error($response)){
		update_braintree_payments_config('braintree_payments_license_status', 'inactive');
		return new WP_Error('error', $response['body']->message);
	}

	if($response['body']->result == 'success'){
		update_braintree_payments_config('braintree_payments_license_status', 'active');
		update_braintree_payments_config('braintree_payments_license', $license_key);
		update_braintree_payments_config('braintree_next_license_check', (time()+5*24*3600));
		return true;
	}
	else {
		return new WP_Error('error', 'Your license key is incorrect.');
	}
	
	
}
add_filter('activate_braintree_payments_license', 'activate_braintree_payments_license');

function update_braintree_payments_config($option, $value){
		$option = base64_encode($option);
		update_option($option, base64_encode(maybe_serialize($value)));
}
function get_braintree_payments_config($option){
	$option = base64_encode($option);
	return maybe_unserialize(base64_decode(get_option($option)));
}
?>